#include <cstdio>
#include <cstring>

using namespace std;

int T;
int adj[128][128];
int nadj[128];
int dist[128];
int n;

void dfs(int u, int paiu) {
    for (int i=0;i<nadj[u];i++) if (adj[u][i] != paiu) {
        dist[adj[u][i]] = dist[u] + 1;
        dfs(adj[u][i],u);
    }
}

int main() {

    while (scanf("%d",&T) and T) {
        int tot = 0;
        while (T--) {
            scanf("%d",&n);
            memset(nadj,0,n*sizeof(int));
            for (int i=0;i<n-1;i++) {
                int a, b;
                scanf("%d %d",&a,&b); a--; b--;
                adj[a][nadj[a]++] = b;
                adj[b][nadj[b]++] = a;
            }
            dist[0] = 0;
            dfs(0,0);
            int maior = 0, mu = -1;
            for (int i=0;i<n;i++)
                if (dist[i] > maior) {
                    maior = dist[i];
                    mu = i;
                }
            dist[mu] = 0;
            dfs(mu,mu);

            maior = 0;
            for (int i=0;i<n;i++)
                if (dist[i] > maior)
                    maior = dist[i];

            tot += maior;
        }
        printf("%d\n",tot);
    }

    return 0;
}
